package aamasfollowbotexample;

import cz.cuni.amis.pogamut.base3d.worldview.object.Location;
import cz.cuni.amis.pogamut.ut2004.agent.module.sensor.AgentInfo;
import cz.cuni.amis.pogamut.ut2004.agent.module.sensor.Game;
import cz.cuni.amis.pogamut.ut2004.agent.module.sensor.Players;
import cz.cuni.amis.pogamut.ut2004.bot.impl.UT2004Bot;
import cz.cuni.amis.pogamut.ut2004.bot.impl.UT2004BotLogicController;

import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.Initialize;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.Move;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.BotKilled;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.ConfigChange;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.GameInfo;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.InitedMessage;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Self;
import cz.cuni.amis.utils.exception.PogamutException;
import cz.cuni.amis.pogamut.ut2004.utils.SingleUT2004BotRunner;

/**
 * Java Bot template.
 */
public class AAMASFollowBotExample extends UT2004BotLogicController {

    Location startLocation = new Location(4800,-800,-3446);

    //declare Pogamut memory/sense modules
    Game game;
    AgentInfo agentInfo;
    Players players;

    @Override
    public void prepareBot(UT2004Bot bot) {
        super.prepareBot(bot); // DO NOT DELETE! RESPECT THE CHAIN!
        // TODO used for initialization, initialize agent modules here

        //initiliaze Pogamut modules
        game = new Game(bot);
        agentInfo = new AgentInfo(bot, game);
        players = new Players(bot, agentInfo);
    }

    @Override
    public Initialize getInitializeCommand() {
        // TODO init bot's params there
        Initialize myInit = new Initialize();
        myInit.setLocation(startLocation);
        return myInit;
    }

    @Override
    public void botInitialized(GameInfo info, ConfigChange config, InitedMessage init) {
        super.botInitialized(info, config, init); // DO NOT DELETE! RESPECT THE CHAIN!
        // TODO called after the bot was initialized
        // since this method, you may use your agent modules
    }

    @Override
    public void botSpawned(GameInfo gameInfo, ConfigChange config, InitedMessage init, Self self) {
        super.botSpawned(gameInfo, config, init, self); // DO NOT DELETE! RESPECT THE CHAIN!
        // bot is spawned for the first time in the environment
        // examine 'self' to examine current bot's location and other stuff
    }

    @Override
    public void logic() throws PogamutException {

        Player player = players.getNearestPlayer(players.getVisiblePlayers().values());
        if (player != null) {
            getAct().act(new Move().setFirstLocation(player.getLocation()));
        }
        // TODO code bots logic there
    }

    @Override
    public void botKilled(BotKilled event) {
        // TODO handle what will happen whent the bot was killed
    }

    /**
     * This method is called when the bot is started either from IDE or from command line.
     * It connects the bot to the game server.
     * @param args
     */
    public static void main(String args[]) throws PogamutException {
        new SingleUT2004BotRunner<UT2004Bot>(AAMASFollowBotExample.class, "AAMASFollowBotExample").startAgent();
    }
}
